//genesis

float MAINVOL = 1e-18	// Spine head volume
float 	BULKVOL = 1e-17	// Dendrite volume
float DIFFCONST = 1e-13	// m^2/sec
int	INTEG = 2			// Adaptive stochastic method
int 	FLAG = 0		// Used for distinguishing filenames

include nonscaf_syn1g.g // same as 1b.g but with Ca input via a reac, and 
				// more plots.

// This little hack is so that the hardcoded handling of the diffusion
// step can recognize the pool, whose name was changed in more recent versions
move /kinetics/MAPK/Raf-GTP-Ras* /kinetics/MAPK/Raf*-GTP-Ras

setfield /editcontrol/vol value {DEFAULT_VOL}

setfield /kinetics/Ca_input CoInit 0.08 slave_enable 4
setfield /kinetics/Ca CoInit 0.08 slave_enable 0
setfield /kinetics/Glu CoInit 0.0 slave_enable 4
setfield /kinetics/EGFR/EGF CoInit 0.0 slave_enable 4

rescale_vol {MAINVOL}

setfield /kinetics/MKP-1 CoInit 0.0024

float BASALDT = 20e-6
float FINEDT = 1e-6

if (INTEG == 0)
	BASALDT = 100e-6
	FINEDT = 10e-6
end

float XA = 1e-14 // 0.1 x 0.1 microns
float LEN = 1e-6 // 1 micron
float fastclock = FINEDT
float normclock = BASALDT
float plotclock = 1
float fastequil = 2
float equiltime = 3000
float tet_time = 100
float CA_STIM = 25
float CA_BASAL = 0.08
float tet_glu_ampl = 1
float post_tet_time = 10000
int save_plot_flag = 1
int PLOT_XDIVS = 200000 // 100 msec accuracy over 5000 sec.

gen_make_1d_diff_pair {BULKVOL} {MAINVOL} {XA} {LEN} {DIFFCONST}

ce /kinetics
clear_non_diffusing_molecules
ce /

move /kinetics/bulk /bulk
add_bulk_plots
move /bulk /kinetics/bulk

str hostname = {getenv HOST}
str fname = "bis_" @ MAINVOL @ "_D_" @ DIFFCONST @ "_" @ hostname @ "_" @ FLAG @ "_" @ INTEG @ "_" @ BULKVOL


function do_phase(duration)
	float duration

	if (INTEG <= 2)
		setclock 0 {fastclock}
		setclock 1 {fastclock}
	end
	if (duration > fastequil)
		step {fastequil} -t
		setclock 0 {normclock}
		setclock 1 {normclock}
		step {duration - fastequil} -t
	else
		step {duration} -t
	end
end

function do_allocate_plot_tabs
	str name
	foreach name ({el /graphs/#/#.Co})
		call {name} TABCREATE {PLOT_XDIVS} 0 1
	end

	foreach name ({el /moregraphs/#/#.Co})
		call {name} TABCREATE {PLOT_XDIVS} 0 1
	end
end

function do_ipi_run

	setfield /kinetics/Ca_input CoInit {CA_BASAL} slave_enable 4
	reset

	setfield /kinetics/Ca_input CoInit {CA_BASAL} slave_enable 4
	do_phase {equiltime}
	setfield /kinetics/Ca_input CoInit {CA_STIM} slave_enable 4
	do_phase {tet_time}
	setfield /kinetics/Ca_input CoInit {CA_BASAL} slave_enable 4
	do_phase {post_tet_time - tet_time}
	do_save_all_plots {fname}.plot
end

if (DO_X == 0)
	do_allocate_plot_tabs
end

do_set_integ_method {INTEG}
randseed2

setclock 0 {BASALDT}
setclock 1 {BASALDT}
setclock 2 {plotclock}
setclock 3 {plotclock}

do_ipi_run
