//genesis

float MAINVOL = 1e-18 // m^3
float DIFFCONST = 1e-15	// m^2/sec
float	LEVEL = 0.25	// uM Ca++
int	INTEG = 2			// stochastic. 0 would be deterministic
int	IS_BISTAB = 1
int	FLAG = 0			// Just a flag for file name


include nonscaf_syn1e.g
setfield /editcontrol/vol value {DEFAULT_VOL}

setfield /kinetics/Ca_input CoInit 0.08 slave_enable 4
setfield /kinetics/Glu CoInit 0.0 slave_enable 4
setfield /kinetics/EGFR/EGF CoInit 0.0 slave_enable 4

rescale_vol {MAINVOL}

if (IS_BISTAB)
	setfield /kinetics/MKP-1 CoInit 0.0024
else
	setfield /kinetics/MKP-1 CoInit 0.0096
end

float BASALDT = 20e-6
float FINEDT = 1e-6

if (INTEG == 0)
	BASALDT = 100e-6
	FINEDT = 10e-6
end

float BULKVOL = 1e-15
float XA = {pow {MAINVOL} 0.6666666667}
float LEN = {pow {MAINVOL} 0.3333333333}
float fastclock = FINEDT
float normclock = BASALDT
float plotclock = 1
float fastequil = 2
float tot_equiltime = 3600
float tet_time = 1
float tet_ca_ampl = 1
float tet_glu_ampl = 1
int save_plot_flag = 1

gen_make_1d_diff_pair {BULKVOL} {MAINVOL} {XA} {LEN} {DIFFCONST}

ce /kinetics
clear_non_diffusing_molecules
ce /

str hostname = {getenv HOST}
str fname = "vol_" @ MAINVOL @ "_D_" @ DIFFCONST @ "_" @ INTEG @ "_" @ IS_BISTAB @ FLAG


int PLOT_XDIVS = 200000 // 100 msec accuracy over 5000 sec.

function do_phase(duration)
	float duration

	if (INTEG <= 2)
		setclock 0 {fastclock}
		setclock 1 {fastclock}
	end
	if (duration > fastequil)
		step {fastequil} -t
		setclock 0 {normclock}
		setclock 1 {normclock}
		step {duration - fastequil} -t
	else
		step {duration} -t
	end
end

function do_allocate_plot_tabs
	str name
	foreach name ({el /graphs/#/#.Co})
		call {name} TABCREATE {PLOT_XDIVS} 0 1
	end

	foreach name ({el /moregraphs/#/#.Co})
		call {name} TABCREATE {PLOT_XDIVS} 0 1
	end
end

function do_dur_run(fname, level)
	str fname
	float level

	setfield /kinetics/Ca_input CoInit {level} slave_enable 4
	reset
	do_phase {tot_equiltime}
	do_save_all_plots {fname}_{level}.plot
end

if (DO_X == 0)
	do_allocate_plot_tabs
end

do_set_integ_method {INTEG}
randseed2

setclock 0 {BASALDT}
setclock 1 {BASALDT}
setclock 2 {plotclock}
setclock 3 {plotclock}
save_plot_flag = 1
reset
do_dur_run {fname} {LEVEL}
